<template>
    <div class="checkbox-item" :style="containerWidth">
        <input type="checkbox" :id="id" :value="value" @change="handleChange" :true-value="trueValue" :false-value="falseValue"/>
        <label :for="id"><slot/></label>
    </div>
</template>

<script>
    export default {
        name: "Checkbox",
        props: {
            value: [String, Number],
            width: [String, Number],
            trueValue: {
                default: () => 1
            },
            falseValue: {
                default: () => 0
            },
        },
        model: {
            prop: 'value',
            event: 'input'
        },
        computed:{
            containerWidth(){
                return {
                    'flex-basis': this.width ? this.width : '100%'
                }
            },
            id(){
                return `checkbox_item_${this._uid}`
            }
        },
        methods: {
            handleChange() {
                this.$emit('change', this.value === this.trueValue ? this.falseValue : this.trueValue);
                this.$emit('input', this.value === this.trueValue ? this.falseValue : this.trueValue);
            }
        }
    }
</script>

<style scoped lang="scss">
    .radio-item, .checkbox-item{
        height: 30px;
        margin-top: 10px;
        flex-basis: 22%;
        display: flex;
        justify-content: space-between;
        align-items: center;
        flex-wrap: wrap;

        input{
            position: absolute;
            z-index: -1;
            opacity: 0;
            margin: 10px 0 0 7px;
        }

        input + .greyColor {
            color: #b0b0b0;
            margin-left: 0;
        }

        label {
            position: relative;
            cursor: pointer;

            color: #c4c4c4;
            font-family: "Geometria Bold";
            font-size: 14px;
            font-weight: 700;
            line-height: 15px;
            transition: color .5s ease;

            &:before {
                content: '';
                position: absolute;
                top: -5px;
                right: -50px;
                width: 22px;
                height: 22px;
                border: 1px solid #CDD1DA;
                border-radius: 50%;
                background-color: #d9d9d9;
                transition: box-shadow .5s ease;
            }
            &:after {
                content: '';
                position: absolute;
                top: -5px;
                right: -49px;
                width: 23px;
                height: 23px;
                border-radius: 50%;
                background: #2b5ede;
                box-shadow: inset 0 1px 1px rgba(0, 0, 0, .5);
                opacity: 0;
                transition: opacity .5s ease;
            }
        }

        :checked{
            + label {
                color: #ffba00;

                &:after{
                    opacity: 1;
                }
                &:before{
                    box-shadow: 0 0 0 3px rgba(255, 255, 0, .7);
                }
            }
        }
    }
</style>
